//+------------------------------------------------------------------+
//|                                               Exp - TimeOpen.mq4 |
//|                                       Copyright  2009, Expforex |
//|                                            http://expforex.at.ua |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Expforex"
#property link      "http://expforex.com"
#property show_inputs
//---- input parameters
extern bool      BuyStopOpen=true;
extern bool      SellStopOpen=true;
extern int       Distance=20;
extern int TPBuyStop=0;
extern int SLBuyStop=0;
extern int TPSellStop=0;
extern int SLSellStop=0;
extern bool CloseAfterOpen = false;
extern double Lots=0.1;
extern int Slippage=1;
extern int Magic=1;

double sl,tp;
int sel,bu;

int start()
  {
//----
if (BuyStopOpen){
if (SLBuyStop  >0) sl=Ask+Distance*Point-SLBuyStop  *Point; else sl=0;
if (TPBuyStop  >0) tp=Ask+Distance*Point+TPBuyStop  *Point; else tp=0;
bu=SetOrder("", OP_BUYSTOP, Lots,Ask+Distance*Point ,sl, tp, Magic);
}

if (SellStopOpen){
if (SLSellStop  >0) sl=Bid-Distance*Point+SLSellStop  *Point; else sl=0;
if (TPSellStop  >0) tp=Bid-Distance*Point-TPSellStop  *Point; else tp=0;
sel=SetOrder("", OP_SELLSTOP, Lots,Bid-Distance*Point, sl, tp, Magic);
}


   return(0);
  }
//+------------------------------------------------------------------+




//+----------------------------------------------------------------------------+
//|      : , Expforex  http://expforex.at.ua                     |
//+----------------------------------------------------------------------------+
//|   :  .                                              |
//+----------------------------------------------------------------------------+
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    pp -                                                                |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - Magic Number                                                       |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
int SetOrder(string sy, int op, double ll, double pp,
              double sl=0, double tp=0, int mn=0, datetime ex=0,string lsComm="") {
  color    clOpen;
  datetime ot;
  double   pa, pb, mp;
  int      err, it, ticket, msl;

  if (sy=="" || sy=="0") sy=Symbol();
  msl=MarketInfo(sy, MODE_STOPLEVEL);
  if (ex>0 && ex<TimeCurrent()) ex=0;
  for (it=1; it<=1; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Print("SetOrder():   ");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    ot=TimeCurrent();
    ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, lsComm, mn, ex, clOpen);
    if (ticket>0) {
    return(ticket);
       break;
    } else {
      err=GetLastError();
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66);
        if (ExistOrders(sy, op, mn, ot)) {
           break;
        }
        continue;
      }
      mp=MarketInfo(sy, MODE_POINT);
      pa=MarketInfo(sy, MODE_ASK);
      pb=MarketInfo(sy, MODE_BID);
      if (pa==0 && pb==0) Comment("SetOrder():       "+sy);
      //  
      if (err==130) {
        switch (op) {
          case OP_BUYLIMIT:
            if (pp>pa-msl*mp) pp=pa-msl*mp;
            if (sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
            if (tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
            break;
          case OP_BUYSTOP:
            if (pp<pa+(msl+1)*mp) pp=pa+(msl+1)*mp;
            if (sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
            if (tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
            break;
          case OP_SELLLIMIT:
            if (pp<pb+msl*mp) pp=pb+msl*mp;
            if (sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
            if (tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
            break;
          case OP_SELLSTOP:
            if (pp>pb-msl*mp) pp=pb-msl*mp;
            if (sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
            if (tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
            break;
        }
        Print("SetOrder():   ");
      }
      //   
      if (err==2 || err==64 || err==65 || err==133) {
         break;
      }
      //  
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      //    (8)     (141)
      if (err==8 || err==141) Sleep(1000*100);
      if (err==139 || err==140 || err==148) break;
      //    
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      //   
      if (err==147) {
        ex=0; continue;
      }
      if (err!=135 && err!=138) Sleep(1000*7.7);
    }
  }
}



//+----------------------------------------------------------------------------+
//|      : , Expforex  http://expforex.at.ua                  |
//+----------------------------------------------------------------------------+
//|    : 19.02.2008                                                      |
//|  :                      |
//+----------------------------------------------------------------------------+
void CPBS() {
  bool   fc;
  color  clClose;
  double ll, pa, pb, pp;
  int    err, it;

  if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
    for (it=1; it<=1; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      pa=MarketInfo(OrderSymbol(), MODE_ASK);
      pb=MarketInfo(OrderSymbol(), MODE_BID);
      if (OrderType()==OP_BUY) {
        pp=pb; 
      } else {
        pp=pa;
      }
      ll=OrderLots();
      fc=OrderClose(OrderTicket(), ll, pp, Slippage, clClose);
      if (fc) {
        break;
      } else {
        err=GetLastError();
        if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
        Sleep(1000*5);
      }
    }
  } else Print("  . Close ",OrderType());
}

//+----------------------------------------------------------------------------+
//|      : , Expforex  http://expforex.at.ua                  |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :                                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
void CPD(string sy="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) CPBS();
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|      : , Expforex  http://expforex.at.ua                     |
//+----------------------------------------------------------------------------+
//|                                                       |
//+----------------------------------------------------------------------------+
bool MagicTotalOrder(int mn,int koll) 
{
  int i, k=OrdersTotal();
  int kol;
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
        if (OrderMagicNumber()==mn) kol++;
      }
  }
  
  if (kol<koll) return(true);
  
  else  return(False);
}


//+----------------------------------------------------------------------------+
//|      : , Expforex  http://expforex.at.ua                  |
//+----------------------------------------------------------------------------+
//|   :    .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                    |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )          |
//+----------------------------------------------------------------------------+
bool ExistOrders(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal(), ty;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ty=OrderType();
      if (ty>1 && ty<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ty==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (ot<=OrderOpenTime()) return(True);
          }
        }
      }
    }
  }
  return(False);
}


//+----------------------------------------------------------------------------+
//|     :   . aka KimIV,  http://www.kimiv.ru                    |
//+----------------------------------------------------------------------------+
//|    : 28.11.2006                                                      |
//|  :                                                  |
//+----------------------------------------------------------------------------+
//| :                                                                 |
//|   sy -     ( ""  -  ,                    |
//|                                    NULL -  )                  |
//|   op -                    (  -1 -  )                     |
//|   mn - MagicNumber                (  -1 -  )                     |
//+----------------------------------------------------------------------------+
void DeleteOrders(string sy="", int op=-1, int mn=-1) {
  bool fd;
  int err, i, it, k=OrdersTotal(), ot;
  
  if (sy=="0") sy=Symbol();
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ot=OrderType();
      if (ot>1 && ot<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ot==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            for (it=1; it<=1; it++) {
              if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
              while (!IsTradeAllowed()) Sleep(5000);
              fd=OrderDelete(OrderTicket());
              if (fd) {
                break;
              } else {
                err=GetLastError();
                Sleep(1000*5);
              }
            }
          }
        }
      }
    }
  }
}

